package com.gic.store.service;

import com.gic.api.base.commons.Page;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.store.dto.StoreBrandDTO;

import java.util.List;

/**
 * @author zhiwj
 * @date 2019/6/24
 */
public interface StoreBrandApiService {

    ServiceResponse<Integer> saveOrUpdateStoreBrand(StoreBrandDTO storeBrandDTO);

    ServiceResponse<Page<StoreBrandDTO>> listStoreBrand(Integer enterpriseId, String search, Integer pageNum, Integer pageSize);

    ServiceResponse<List<StoreBrandDTO>> listAllStoreBrand(Integer enterpriseId, String search, Integer storeSupport, Integer goodsSupport);

    /**
     * 批量删除
     * @param ids
     * @return 不能被删除的品牌（在使用中的品牌）
     */
    ServiceResponse deleteByIds(Integer enterpriseId, String ids);

    /**
     * 移动顺序
     */
    ServiceResponse moveStoreBrand(Integer enterpriseId, Integer storeBrandId, Integer moveType);

    /**
     * 设置序号
     * @param storeBrandId
     * @param seq 序号
     * @return
     */
    ServiceResponse setStoreBrandSort(Integer enterpriseId, Integer storeBrandId, Integer seq);



}
