package com.gic.store.service;

import com.gic.store.dto.StoreFieldDTO;
import com.gic.store.entity.TabStoreField;
import com.github.pagehelper.Page;

import java.util.List;

/**
 * @author guojx
 * @date 2019/7/1 9:12 AM
 */
public interface StoreFieldService {

    /**
     * 新增
     * @param storeFieldDTO
     * @return
     */
    int save(StoreFieldDTO storeFieldDTO);

    int edit(StoreFieldDTO storeFieldDTO);

    /**
     *
     * @param storeFieldCode
     * @param enterpriseId
     * @return
     */
    boolean isStoreFieldCodeRepeat(String storeFieldCode, int enterpriseId);

    /**
     * 查询下一个排序值的属性值
     * @param enterpriseId
     * @param sort
     * @return
     */
    TabStoreField getNextSort(int enterpriseId, double sort);

    /**
     * 查询上一个排序值的属性值
     * @param enterpriseId
     * @param sort
     * @return
     */
    TabStoreField getPrevSort(int enterpriseId, double sort);

    /**
     * 根据主键查询
     * @param storeFieldId
     * @return
     */
    TabStoreField getStoreFieldById(int storeFieldId);

    /**
     * 更新序号
     * @param storeFieldId
     * @param sort
     * @return
     */
    int updateSortById(int storeFieldId, double sort);

    int deleteAll(int enterpriseId);

    int deleteBatch(List<Integer> storeFieldIds);

    /**
     * 置顶、置底，自定义序号
     * @param storeFieldId
     * @param enterpriseId
     * @param setValue
     */
    void setStoreFieldSort(int storeFieldId, int enterpriseId, int setValue);

    int delete(int storeFieldId);

    /**
     * 分页查询列表数据
     * @param enterpriseId
     * @param search
     * @param pageNum
     * @param pageSize
     * @return
     */
    Page<TabStoreField> listStoreField(int enterpriseId, String search, Integer pageNum, Integer pageSize);

    double getMinSort(int enterpriseId);

    boolean isRepeatCode(Integer enterpriseId, Integer storeFieldId, String storeFieldCode);

    boolean isRepeatName(Integer enterpriseId, Integer storeFieldId, String storeFieldName);

    /**
     * 置底
     * @param enterpriseId
     * @param storeFieldId
     */
    void sortBottom(int enterpriseId, int storeFieldId);

    /**
     * 置顶
     * @param enterpriseId
     * @param storeFieldId
     */
    void sortTopping(int enterpriseId, int storeFieldId);

    /**
     * 根据域主键查询字段列表数据
     * @param regionId
     * @return
     */
    List<TabStoreField> listStoreFieldByRegionId(Integer regionId);


    /**
     * 根据企业ID查询列表
     * @param enterpriseId
     * @return
     */
    List<TabStoreField> listStoreFieldByEnterpriseId(Integer enterpriseId);

    /**
     * 查询
     * @param storeFieldIds
     * @return
     */
    List<TabStoreField> listByBatchId(List<Integer> storeFieldIds);
}
