package com.gic.store.web.controller;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.commons.util.EntityUtil;
import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.enterprise.response.EnterpriseRestResponse;
import com.gic.store.dto.StoreDictDTO;
import com.gic.store.service.StoreDictApiService;
import com.gic.store.utils.ErrorCode;
import com.gic.store.web.vo.StoreDictVO;
import org.apache.commons.lang.StringUtils;
import org.apache.log4j.LogManager;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.List;

@Controller
public class StoreDictController {
    private Logger logger = LogManager.getLogger(StoreDictController.class);
    @Autowired
    private StoreDictApiService storeDictApiService;

    @RequestMapping("list-all-storetype")
    @ResponseBody
    public Object listAllStoreType(){
        Integer enterpriseId = 1111;
        ServiceResponse<List<StoreDictDTO>> serviceResponse = this.storeDictApiService.listAllStoreType(enterpriseId);
        if(serviceResponse.isSuccess()){
            return RestResponse.success(EntityUtil.changeEntityListByJSON(StoreDictVO.class, serviceResponse.getResult()));
        }else {
            return RestResponse.failure(serviceResponse.getCode(), serviceResponse.getMessage());
        }
    }

    @RequestMapping("list-all-storestatus")
    @ResponseBody
    public RestResponse listAllStoreStatus(){
        Integer enterpriseId = 1111;
        ServiceResponse<List<StoreDictDTO>> serviceResponse = this.storeDictApiService.listAllStoreStatus(enterpriseId);
        if(serviceResponse.isSuccess()){
            return RestResponse.success(EntityUtil.changeEntityListByJSON(StoreDictVO.class, serviceResponse.getResult()));
        }else {
            return RestResponse.failure(serviceResponse.getCode(), serviceResponse.getMessage());
        }
    }

    @RequestMapping("list-storetype")
    @ResponseBody
    public RestResponse listStoreType(){
        Integer enterpriseId = 1111;
        ServiceResponse<List<StoreDictDTO>> serviceResponse = this.storeDictApiService.listStoreType(enterpriseId);
        if(serviceResponse.isSuccess()){
            return RestResponse.success(EntityUtil.changeEntityListByJSON(StoreDictVO.class, serviceResponse.getResult()));
        }else {
            return RestResponse.failure(serviceResponse.getCode(), serviceResponse.getMessage());
        }
    }

    @RequestMapping("list-storestatus")
    @ResponseBody
    public RestResponse listStoreStatus(){
        Integer enterpriseId = 1111;
        ServiceResponse<List<StoreDictDTO>> serviceResponse = this.storeDictApiService.listStoreStatus(enterpriseId);
        if(serviceResponse.isSuccess()){
            return RestResponse.success(EntityUtil.changeEntityListByJSON(StoreDictVO.class, serviceResponse.getResult()));
        }else {
            return RestResponse.failure(serviceResponse.getCode(), serviceResponse.getMessage());
        }
    }

    @RequestMapping("save-storetype")
    @ResponseBody
    public RestResponse saveStoreType(String storeTypes){
        Integer enterpriseId = 1111;
        if(StringUtils.isBlank(storeTypes)){
            return RestResponse.failure(ErrorCode.ERR_2.getCode(), ErrorCode.ERR_2.getMsg());
        }
        ServiceResponse serviceResponse = this.storeDictApiService.saveStoreType(enterpriseId, storeTypes.split(","));
        if(serviceResponse.isSuccess()){
            return RestResponse.success();
        }else {
            return RestResponse.failure(serviceResponse.getCode(), serviceResponse.getMessage());
        }
    }

    @RequestMapping("save-storestatus")
    @ResponseBody
    public RestResponse saveStoreStatus(String storeStatus){
        Integer enterpriseId = 1111;
        if(StringUtils.isBlank(storeStatus)){
            return RestResponse.failure(ErrorCode.ERR_2.getCode(), ErrorCode.ERR_2.getMsg());
        }
        ServiceResponse serviceResponse = this.storeDictApiService.saveStoreStatus(enterpriseId, storeStatus.split(","));
        if(serviceResponse.isSuccess()){
            return RestResponse.success();
        }else {
            return RestResponse.failure(serviceResponse.getCode(), serviceResponse.getMessage());
        }
    }

//    @RequestMapping("relevance-storefield")
//    @ResponseBody
//    public RestResponse setStoreField(String value, int type){
//        Integer enterpriseId = 1111;
//        if(StringUtils.isBlank(value)){
//            return EnterpriseRestResponse.failure(com.gic.enterprise.error.ErrorCode.ERR_2);
//        }
//        ServiceResponse serviceResponse = this.storeDictApiService.saveStoreField(enterpriseId, value, type);
//        if(serviceResponse.isSuccess()){
//            return RestResponse.success();
//        }
//        return EnterpriseRestResponse.failure(serviceResponse);
//    }

    @RequestMapping("list-storefield-relevance")
    @ResponseBody
    public RestResponse listStoreFieldRelevance(){
        Integer enterpriseId = 1111;
        ServiceResponse serviceResponse = this.storeDictApiService.listStoreField(enterpriseId);
        if(serviceResponse.isSuccess()){
            return RestResponse.success(EntityUtil.changeEntityListByJSON(StoreDictVO.class, serviceResponse.getResult()));
        }
        return EnterpriseRestResponse.failure(serviceResponse);
    }

}
